#ifndef _WHITEBOARD_H_
#define _WHITEBOARD_H_

#ifdef _VIPER_WIDE
#include <ncursesw/curses.h>
#else
#include <curses.h>
#endif

#include "vscreen.h"

/*
   NOTES from ncures man pages:

   If ch is a tab, newline, or backspace, the cursor is moved appropriately
   within the window.  Backspace moves the cursor one character left;  at
   the left edge of a window it does nothing. Newline does a clrtoeol, then
   moves the cursor to the window left margin on the next line, scrolling the
   window if on the last line. Tabs are considered to be at every eighth
   column.  The tab interval may be altered by setting the TABSIZE variable.

   The TABSIZE variable is implemented in some versions of curses, but is not
   part of X/Open curses.

   If ch is a carriage return, the cursor is moved to the beginning of the
   current row of the window.  This is true of other implementations, but
   is not documented.
*/

vscreen_t* whiteboard_vscreen_from(WINDOW *source,guint pty_fd);

#endif

