#ifndef _H_VWM_SCRSAVER_
#define _H_VWM_SCRSAVER_

#include <glib.h>

#ifdef _VIPER_WIDE
#include <ncursesw/curses.h>
#else
#include <curses.h>
#endif

#include <pseudo.h>

#define  SCRSAVER_STATE_ACTIVE   (1<<1)   /* the timer is running */
#define  SCRSAVER_STATE_RUNNING  (1<<2)   /* the screensaver is visible */
#define  SCRSAVER_STATE_RESET    (1<<3)   /* the timer is to be reset   */
#define  SCRSAVER_STATE_AWOKEN   (1<<4)   /* the screensaver just terminated  */

/* typedef struct
{
   WINDOW   *window;
   WINDOW   *subwin;
   FORM     *form;
   GSList   *scrsaver_list;
   gint     scrsaver_count;
}
VWM_APP_SCRSAVER_CONTROL; */

/*	this callback is the screensaver control center which actually
	appears on the Main Menu.	*/
WINDOW*	vwm_fmod_scrsaver(gpointer anything);
/*	this callback is used to overwrite any existing keyboard handler of the
	module and make usre the password auth mechanism is used.	*/
gint 		vwm_fmod_scrsaver_ON_KEYSTROKE(gint32 keystroke,WINDOW *window);

/*	this callback is the built in screensaver.  screensavers do not appear
	on the Main Menu.	instead, they are managed by the screensaver control
	center	*/
WINDOW*	vwm_fmod_sysinfo(gpointer anything);

gint		vwm_scrsaver_timer(ps_task_t *task,gpointer anything);

gint		vwm_fmod_scrsaver_ON_CLOSE(WINDOW *window,gpointer arg);
gint		vwm_fmod_scrsaver_ON_ACTIVATE(WINDOW *window,gpointer arg);
gint		vwm_fmod_scrsaver_ON_MOVE(WINDOW *window,gpointer arg);
gint		vwm_fmod_scrsaver_menu_ON_KEYSTROKE(gint32 keystroke,WINDOW *window);
gint		vwm_fmod_scrsaver_form_ON_KEYSTROKE(gint32 keystroke,WINDOW *window);

/*	helper functions	*/
void		vwm_fmod_scrsaver_update(WINDOW *window);
void     vwm_scrsaver_state_set(guint32 state);
#define  vwm_scrsaver_reset()    (vwm_scrsaver_state_set(SCRSAVER_STATE_RESET))


#endif
